/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 14.10.2009
Author  : Name
Company : Organisation
Comments: 


Chip type               : AT90USB1287
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 2048
*****************************************************/

#include <90usb1287.h>
#include <delay.h>


//   USB 

// USBCON
#define USBE    7
#define HOST    6
#define FRZCLK  5
#define OTGPADE 4
#define IDTE    1
#define VBUSTE  0

// UHWCON
#define UIMOD 7
#define UIDE 6
#define UVCONE  4
#define UVREGE 0

// USBINT
#define IDTI   1
#define VBUSTI 0

// UDCONE 
#define DETACH  0

// OTGCON
#define SPRSEL  3
#define VBUSHWC 2
#define VBUSREQ 1
#define VBUSRQC 0

// UHIEN
#define HWUPE 6
#define HSOFE 5
#define DDISCE  1
#define DCONNE 0

// UPCONX 
#define PFREEZE 6
#define INMODE 5
#define RSTDT 3
#define PEN 0

// UPCFG1X
#define ALLOC 1

// UPSTAX
#define CFGOK 7

// UPIENX
#define TXSTPE 3
#define RXINE 0

// UPINTX
#define FIFOCON  7
#define NAKEDI   6
#define TXOUTI   2
#define TXSTPI   3
#define RXSTALLI 1
#define RXINI    0 

// UHCON
#define SOFEN 0
#define RESET 1

// UHINT
#define HWUPI  6
#define HSOFI  5
#define RSTI   2
#define DDISCI 1
#define DCONNI 0

// OTGIEN
#define SRPE 0

// PLLCSR
#define PLLP2 4
#define PLLP1 3
#define PLLP0 2
#define PLLE  1
#define PLOCK 0

#define tokSETUP 0
#define tokIN    1
#define tokOUT   2

// USB
#define usb_enable_device_connection_interrupt() (UHIEN |= (1<<DCONNE))               //    
#define usb_disable_device_connection_interrupt() (UHIEN &= ~(1<<DCONNE))             //    
#define usb_enable_device_disconnection_interrupt() (UHIEN |= (1<<DDISCE))            //    
#define usb_disable_device_disconnection_interrupt() (UHIEN &= ~(1<<DDISCE))          //    
#define usb_enable_SOF_interrupt() (UHIEN |= (1<<HSOFE))                              //     
#define usb_disable_SOF_interrupt() (UHIEN &= ~(1<<HSOFE))                            //     
#define usb_start_SOF_generation() (UHCON |= (1<<SOFEN))                              //  SOF
#define usb_stop_SOF_generation() (UHCON &= ~(1<<SOFEN))                              //  SOF
#define usb_Is_device_attached() ((UHINT & (1<<DCONNI))  ? 1 : 0)                     //  (1-, 0- )
#define usb_ack_device_attached() (UHINT &= ~(1<<DCONNI))                             //   
#define usb_ack_host_wake_up() (UHINT &= ~(1<<HWUPI))                                 //   
#define usb_Is_hos_wakeup() ((UHINT & (1<<HWUPI))  ? 1 : 0)                           //   (1-, 0-)
#define usb_reset_bus()  (UHCON |= (1<<RESET))                                        //  usb
#define usb_Is_reset_bus() ((UHCON & (1<<RESET)) ? 1 : 0)                              // 
#define usb_ack_device_disconnection() (UHINT &= ~(1<<DDISCI))
#define usb_clear_UHINT() (UHINT=0x00)
#define usb_Is_SOF_complete() ((UHINT & (1<<HSOFI)) ? 1 : 0) 
#define usb_ack_SOF() (UHINT &= ~(1<<HSOFI))
#define usb_Is_get_NAK() ((UPINTX & (1<<NAKEDI)) ? 1 : 0) 
#define usb_ack_NAK() (UPINTX &= ~(1<<NAKEDI)) 
#define usb_Is_get_STALL() ((UPINTX & (1<<RXSTALLI)) ? 1 : 0) 
#define usb_ack_STALL() (UPINTX &= ~(1<<RXSTALLI)) 
//#define usb_reset_pipe(x) (UPRST=x; UPRST=0x00;)

#define CBWLength 31
#define CSWLength 13 

#define PLLx03                  ((1<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define Start_pll(clockfactor)  (PLLCSR = ( clockfactor  | (1<<PLLE)  ))
#define Pll_start_auto()         Start_pll(PLLx03)
#define Wait_pll_ready()         while (!(PLLCSR & (1<<PLOCK)))

void usb_hardware_init(void);
void usb_setup_control_pipe(void);
void usb_setup_pipe(unsigned char type, unsigned char num_pipe);
void usb_wait_SOF(unsigned char num);
void usb_send_packet(unsigned char token, unsigned char pipe_num, unsigned char *data, unsigned char num);
unsigned char usb_read_packet(unsigned char *data);
void usb_enumerate_device(void);
void usb_reset_pipe(unsigned char num);
unsigned char usb_IN_Transfer(unsigned char pipe_num,unsigned char *data);

struct 
{
  unsigned char detect_SRP: 1;
} usb_flags;

struct 
{
  unsigned char SOF; 
  //unsigned char max_SOF;
} usb_counts;

struct
{
  unsigned char ep_in;
  unsigned char ep_out;
  
}usb_vars;
unsigned char a,index;//,a1,c,data_length,q;
unsigned char usb_rx_buf[512];
unsigned char usb_setup[8];
unsigned char usb_control_ep_size;
unsigned char usb_status;
unsigned char usb_CSW_buf[13];
//  CBW
// SCSI    CBW   15- 
//SCSI Inquiry command
/*
0 -   012
1 -  7-2   0. 
     1 - CmdDT -      0
     0 - EvPd -      0
2 - Page or operation code      0,      
*/
unsigned char CBW_Inquiry[CBWLength] = {0x55,0x53,0x42,0x43,0x08,0xC0,0x5B,0x81,
                                        0x24,0x00,0x00,0x00,0x80,0x00,0x06,0x12,
                                        0x00,0x00,0x00,0x24,0x00,0x00,0x00,0x00,
                                        0x00,0x00,0x00,0x00,0x00,0x00,0x00};
/*unsigned char host_config_pipe(unsigned char config0, unsigned char config1)
{
    Host_enable_pipe();
    UPCFG0X = config0;
    UPCFG1X = config1;
    Host_allocate_memory();
    return (Is_pipe_configured());
} */


// USB general interrupt service routine
interrupt [USB_GENERAL] void usb_general_isr(void)
{
  if (UHINT & 2)
   {
   // Device Disconnection interrupt
   // Place your code here
    //usb_stop_SOF_generation(); 
    //OTGCON |= (1<<VBUSRQC); //  
    UHINT=0x00;
   }
  
  if (UHINT & 0x20)
     {
       // Host Start Of Frame interrupt
       // Place your code here
       usb_counts.SOF++;
       UHINT &= ~(1<<HSOFI);
       //if (usb_counts.SOF==usb_counts.max_SOF)
         
     }
if (USBINT & 1)
   {
     USBINT &= ~(1<<VBUSTI);
     //UHINT=0x00;
     //OTGINT=0x00;
     //USBINT=0x00;
    //UHINT&=~(1<<HWUPI);  
    //UHCON|= (1<<SOFEN);                 //  SOF
   }
if (USBINT & 2)
   {
   // ID Transition interrupt
   // Place your code here
    a=2;
   }
USBINT=0; // Clear the interrupt flags
if (OTGINT & 1)
   {
   // SRP interrupt
   // Place your code here 
      usb_flags.detect_SRP = 1;
      OTGCON |= (1<<VBUSREQ); //  
   }
if (OTGINT & 2)
   {
   // V-Bus Error interrupt
   // Place your code here
       a=4;
   }
if (OTGINT & 4)
   {
   // B-Connection Error interrupt
   // Place your code here
       a=5;
   }
if (OTGINT & 8)
   {
   // Role Exchange interrupt
   // Place your code here
       a=6;
   }
if (OTGINT & 0x10)
   {
   // HNP Error interrupt
   // Place your code here
      a=7;
   }
if (OTGINT & 0x20)
   {
   // Suspend Time-out Error interrupt
   // Place your code here
      a=8;
   }  
//if (UHINT!=0)
//  {
//    UHINT=0x00;
//  }
OTGINT=0; // Clear the interrupt flags
}

// USB Host/Pipe interrupt service routine
interrupt [USB_ENDPOINT_PIPE] void usb_host_pipe_isr(void)
{
if (UHINT & 1)
   {
   // Device Connection interrupt
   // Place your code here
      a=9; 
      
   }
if (UHINT & 2)
   {
   // Device Disconnection interrupt
   // Place your code here
       a=10;
   }
if (UHINT & 4)
   {
   // USB Reset Sent interrupt
   // Place your code here
        a=11;
   }
if (UHINT & 8)
   {
   // Downstream Resume Sent interrupt
   // Place your code here
       a=12;
       
   }
if (UHINT & 0x10)
   {
   // Upstream Resume Received interrupt
   // Place your code here
        a=13;
   }
if (UHINT & 0x20)
   {
   // Host Start Of Frame interrupt
   // Place your code here
     usb_counts.SOF++;
   }
if (UHINT & 0x40)
   {
   // Host Wake-up interrupt
   // Place your code here
       a=15; 
      //a=1;
     //UHCON|= (1<<SOFEN); //  SOF
   }
UHINT=0; // Clear the interrupt flags
if (UPINTX & 1)
   {
   // IN Data Received interrupt
   // Place your code here
         a=16; 
     //count = (UPBCHX<<8)|UPBCLX;
     //for (index=0; index<count;index++)
     //  {
      //   rx_buf[index]=UPDATX;
      // } 
     ///UPINTX&= (~(1<<RXINI));
   }
if (UPINTX & 2)
   {
   // STALL Received/Isochronous CRC Error interrupt
   // Place your code here
       a=17;
   }
if (UPINTX & 4)
   {
   // OUT Bank Ready interrupt
   // Place your code here
       a=18;
   }
if (UPINTX & 8)
   {
   // SETUP Bank Ready interrupt
   // Place your code here 
    

      UPINTX&=(~(1<<TXSTPI));// -   TXSTPI
    
   
   }
if (UPINTX & 0x10)
   {
   // Pipe Error interrupt
   // Place your code here
       a=20;
   }
if (UPINTX & 0x40)
   {
   // NAK Handshake Received interrupt
   // Place your code here
       a=21;
   }
UPINTX&=0xA0; // Clear the interrupt flags
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Port E initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTE=0x20;
DDRE=0x00;
//PORTE=0x80;
//PORTE=0x00;
//DDRE=0x00;

// Port F initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTF=0x00;
DDRF=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// OC1C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// Timer/Counter 3 initialization
// Clock source: System Clock
// Clock value: Timer 3 Stopped
// Mode: Normal top=FFFFh
// OC3A output: Discon.
// OC3B output: Discon.
// OC3C output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 3 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
// Compare C Match Interrupt: Off
TCCR3A=0x00;
TCCR3B=0x00;
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// INT3: Off
// INT4: Off
// INT5: Off
// INT6: Off
// INT7: Off
EICRA=0x00;
EICRB=0x00;
EIMSK=0x00;
// PCINT0 interrupt: Off
// PCINT1 interrupt: Off
// PCINT2 interrupt: Off
// PCINT3 interrupt: Off
// PCINT4 interrupt: Off
// PCINT5 interrupt: Off
// PCINT6 interrupt: Off
// PCINT7 interrupt: Off
PCMSK0=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x00;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;
// Timer/Counter 3 Interrupt(s) initialization
TIMSK3=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

usb_flags.detect_SRP=0;
Pll_start_auto();
Wait_pll_ready();    
// USB 
usb_hardware_init();
//UHIEN|=(1<<6);
// 
//usb_setup_control_pipe();
//usb_setup_out_pipe();
//--------------------
//      1-  SRP, .     ., 
//  1    OTGINT
delay_ms(1);
OTGINT=0;
//--------------------
#asm("sei")
//usb_enable_device_disconnection_interrupt();
                //usb_reset_bus(); 
                //while (usb_Is_reset_bus());
                //usb_ack_device_disconnection();  
while (1)
      { 
            if (usb_Is_device_attached() & usb_Is_hos_wakeup())
              { 
                usb_ack_device_attached();
                usb_ack_host_wake_up();
                usb_start_SOF_generation();  
                usb_wait_SOF(200);                      // 200      
                usb_enumerate_device();
                for (index=0x00; index<0x12;index++)
                   usb_rx_buf[index]=0x00;
                usb_setup_pipe(1,usb_vars.ep_out);
                usb_setup_pipe(0,usb_vars.ep_in);  
                usb_send_packet(tokOUT,usb_vars.ep_out,CBW_Inquiry,CBWLength);
                usb_status = usb_IN_Transfer(usb_vars.ep_in,usb_rx_buf);
                usb_status = usb_IN_Transfer(usb_vars.ep_in,usb_CSW_buf);  // CSW-  
                #asm("NOP")
              }


      };
}

 void usb_setup_control_pipe(void)
  {
    usb_reset_pipe(0);
    UPNUM=0x00;   //  0
    UPCONX|=(1<<PEN); // 
    UPCFG0X=0x00; //  - ,  - SETUP,  - 0
    UPCFG1X=0x30; // 64 ,   - 1.
    UPCFG1X |= (1<<ALLOC); //  
    while ((UPSTAX&0x80)!=0x80); //    
    UECONX=0x01;      // 
  }   
  
 void usb_setup_pipe(unsigned char type, unsigned char num_pipe)
   {
    usb_reset_pipe(num_pipe);
    UPNUM = num_pipe;            //  
    UPCONX|=(1<<PEN);             // 
    if (type==0)
        UPCFG0X = 0x90|num_pipe;                 // - bulk,  - IN
    else if (type==1)
        UPCFG0X=0xA0|num_pipe;                 // - bulk,  - OUT
    UPCFG1X=0x30;                 // 64 ,   - 1.
    UPCFG1X |= (1<<ALLOC);        //  
    while ((UPSTAX&0x80)!=0x80);  //   
    UECONX=0x01;                  // 
   } 
 void usb_hardware_init(void)
  {
    USBCON = ~((1<<USBE)|(1<<OTGPADE)); // USB 
    UHWCON &= ~(1<<UIDE);               //      UIMOD 
    UHWCON &= ~(1<<UIMOD);              //.  ,    
    USBCON = ((1<<USBE)|(1<<OTGPADE));  // USB
    USBCON &= ~(1<<FRZCLK);             //  USB
    UDCON  &= ~(1<<DETACH);             //  DETACH( )
    UHWCON |= (1<<UVCONE);              //    UVCON
    USBCON |= (1<<HOST);                // -   
    OTGCON |= (1<<VBUSHWC);             //    UVCON 
    USBCON &= ~((1<<IDTE)|(1<<VBUSTE)); //   VBUS  ID
    UHIEN&= ~(1<<HWUPE);
    UHINT=0x00;
    UHFLEN=0x00;  
    USBINT=0x00;
    OTGCON|= (1<<SPRSEL);               //   SPR         
    OTGIEN|=(1<<SRPE);                  //   SPR
    OTGINT=0x00; 
    
  }
void usb_wait_SOF(unsigned char num)
 { 
   usb_counts.SOF=0x00; 
   while (usb_counts.SOF<num)
    {
      if (usb_Is_SOF_complete())
        { 
          usb_ack_SOF();
          usb_counts.SOF++;
        }
    }
 }
 
void usb_send_packet(unsigned char token, unsigned char pipe_num, unsigned char *data, unsigned char num)
  {    
    unsigned char jndex;
    usb_reset_pipe(pipe_num);
    UPNUM = pipe_num;
    UPCFG0X= (UPCFG0X & ~0x30)|pipe_num; 
    UPINTX&= ~(1<<TXSTPI);  
    UPCFG0X |= (token<<4);              //  
    UPCONX&= ~(1<<PFREEZE);             //    
    for (jndex=0;jndex<num;jndex++)       //   FIFO
        UPDATX = data[jndex];   
    UPINTX &= ~(1<<FIFOCON);           //  FIFOCON -     
    if (pipe_num) 
      {
         while ((UPINTX&(1<<TXOUTI))!=0x04); //     
         UPINTX&= ~(1<<TXOUTI);
      }
    else
      { 
         while ((UPINTX&(1<<TXSTPI))!=0x08); //     
         UPINTX&= ~(1<<TXSTPI);              //  
      }
    UPCONX |=  (1<<PFREEZE);            //      
  }  
unsigned char usb_read_packet(unsigned char *data)
  {  
    unsigned char in_num;
    unsigned char jndex;
    unsigned char status = 0x00;
    
    usb_wait_SOF(1);                    // 1                  
    UPCONX&= ~(1<<INMODE);              // 1 IN   .
    UPCFG0X=((UPCFG0X& ~0x30)|0x10);    //   IN
    UPCONX &=  ~(1<<PFREEZE);           //    
    while ((UPINTX&0x01)!=0x01)        // ,   RXINI
      {
        if (usb_Is_get_NAK())
          {
            usb_ack_NAK();
            status = 0x01;
            break;   
            //return status;
          } 
        if (usb_Is_get_STALL()) 
          {  
            usb_ack_STALL(); 
            status  = 0x02;
            break;  
            //return status;
          }
      }
    if (status == 0x00)
      {  
        in_num=UPBCLX;                      //   
        for (jndex=0;jndex<in_num;jndex++)
         {
           data[jndex] = UPDATX;
         }
      }
    UPINTX  &= ~(1<<RXINI);
    UPCONX |=  (1<<PFREEZE);  
    //-------------------------------------------------------------------------------------
    //          
    //   ACK .     
    //  .
    if ((usb_setup[0]!=0x00)&(usb_setup[1]!=0xFF))
    {
      usb_wait_SOF(1);                    // 1   
      usb_reset_pipe(0);
      UPNUM = 0;
      UPCFG0X= (UPCFG0X & ~0x30)|(0<<4); 
      UPINTX&= ~(1<<TXSTPI);
      UPCFG0X= ((UPCFG0X & ~0x30)|0x20);           //  OUT    
      UPINTX&= ~(1<<TXOUTI); 
      UPCONX&= ~(1<<PFREEZE);             //    
      UPINTX &= ~(1<<FIFOCON);           //  FIFOCON -       
      while ((UPINTX&(1<<TXOUTI))!=0x04);  
      UPINTX&= ~(1<<TXOUTI);
      UPCONX |=  (1<<PFREEZE);            //    
    }   
   //-------------------------------------------------------------------------------------   
   return status;
  }
unsigned char usb_IN_Transfer(unsigned char pipe_num,unsigned char *data)
{
    unsigned char in_num,iPROD,iMFG,iSERIAL;
    unsigned char jndex;
    unsigned char status = 0x00;
    usb_reset_pipe(pipe_num);  
    UPNUM = pipe_num;             
    UPCONX&= ~(1<<INMODE);                    // 1 IN   .
    UPCFG0X=((UPCFG0X& ~0x30)|(tokIN<<4));    //   IN
    UPCONX &=  ~(1<<PFREEZE);                 //    
    while ((UPINTX&0x01)!=0x01)               // ,   RXINI
      {
        if (usb_Is_get_NAK())
          {
            usb_ack_NAK();
            status = 0x01;   
            break;
          } 
        if (usb_Is_get_STALL()) 
          {  
            usb_ack_STALL(); 
            status  = 0x02;  
            break;
          }
      }
    if (status == 0x00)
      {  
        in_num=UPBCLX;                      //   
        for (jndex=0;jndex<in_num;jndex++)
         {
           data[jndex] = UPDATX;
         }
      }
    UPINTX  &= ~(1<<RXINI);
    UPCONX |=  (1<<PFREEZE);  
    return (status);
}
  
void usb_enumerate_device(void)
 {    
   //unsigned char usb_setup[8];
   unsigned char iMFG,iSERIAL,iPROD,iCONFIG;
   usb_reset_bus();                        // ,   
   while (usb_Is_reset_bus());             //   
   usb_clear_UHINT();                      //    UHINT
   usb_wait_SOF(200);                      // 200     
   usb_setup_control_pipe();               // SETUP   
   //Get_Descriptor_Device
   usb_setup[0]=0x80;
   usb_setup[1]=0x06;
   usb_setup[2]=0x00;
   usb_setup[3]=0x01;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x08;
   usb_setup[7]=0x00; 
   //do
   //{
   usb_send_packet(0,0,usb_setup,8); 
   usb_status = usb_read_packet(usb_rx_buf);
   //if (usb_status)
   //  {
   //    usb_reset_pipe(0);
   //    delay_ms(100);
   //  }
   usb_control_ep_size = usb_rx_buf[7];
  // } while (usb_control_ep_size==0x00);
   //delay_ms(100);  
   //    0,          
   usb_reset_bus();                        // ,   
   while (usb_Is_reset_bus());             //   
   usb_clear_UHINT();                       //    UHINT
   usb_wait_SOF(200);                      // 200    
   delay_ms(100);  
   usb_clear_UHINT(); 
   usb_setup_control_pipe();               // SETUP 
   //   7,     SET_ADDRESS   
   usb_setup[0]=0x00;
   usb_setup[1]=0x05; 
   usb_setup[2]=0x07;
   usb_setup[3]=0x00;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x00;
   usb_setup[7]=0x00; 
   usb_send_packet(0,0,usb_setup,8); 
   usb_status = usb_read_packet(usb_rx_buf);     
   usb_wait_SOF(30);                      // 30     
   //delay_ms(100);
   UHADDR = 0x07;                         //     ,          0x07
   //    Get_Descriptor_Device,        18 
   usb_setup[0]=0x80;
   usb_setup[1]=0x06; 
   usb_setup[2]=0x00;
   usb_setup[3]=0x01;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x12;
   usb_setup[7]=0x00;
   usb_send_packet(0,0,usb_setup,8);
   usb_status = usb_read_packet(usb_rx_buf);
   iMFG = usb_rx_buf[14];
   iPROD = usb_rx_buf[15];
   iSERIAL = usb_rx_buf[16];
      //delay_ms(100); 
   //   Get_Descriptor-String template
   /*usb_setup[0]=0x80;
   usb_setup[1]=0x06; 
   usb_setup[2]=0x00;
   usb_setup[3]=0x03;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x04;
   usb_setup[7]=0x00;
   usb_send_packet(0,0,usb_setup,8);
   usb_status = usb_read_packet(usb_rx_buf);*/
   if (iMFG)
     {
       usb_setup[2] = iMFG;
       usb_send_packet(0,0,usb_setup,8);
       usb_status = usb_read_packet(usb_rx_buf);
     }
   if (iPROD)
     {
       usb_setup[2] = iPROD;
       usb_send_packet(0,0,usb_setup,8);
       usb_status = usb_read_packet(usb_rx_buf);
     }  
   if (iSERIAL)
     {
       usb_setup[2] = iSERIAL;
       usb_send_packet(0,0,usb_setup,8);
       usb_status = usb_read_packet(usb_rx_buf);
     }    
   //   Get_Descriptor_Config
   usb_setup[0]=0x80;
   usb_setup[1]=0x06; 
   usb_setup[2]=0x00;
   usb_setup[3]=0x02;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x09;
   usb_setup[7]=0x00;   
   usb_send_packet(0,0,usb_setup,8);
   usb_status = usb_read_packet(usb_rx_buf);
   //delay_ms(100);
   usb_setup[6]= usb_rx_buf[2];	// LengthL
   usb_setup[7]= usb_rx_buf[3];	// LengthH
   //usb_setup[6]= 0xFF;	// LengthL
   //usb_setup[7]= 0x00;	// LengthH
   usb_send_packet(0,0,usb_setup,8);
   usb_status = usb_read_packet(usb_rx_buf);
   iCONFIG  = usb_rx_buf[6];   
   if ((usb_rx_buf[20]&0x80)==0x80)
    {
      usb_vars.ep_in = (usb_rx_buf[20]&0x0F);
    }
   else
    {
       usb_vars.ep_out = (usb_rx_buf[20]&0x0F);
    }
   if ((usb_rx_buf[27]&0x80)==0x80)
    {
       usb_vars.ep_in = (usb_rx_buf[27]&0x0F);
    }
   else
    {
       usb_vars.ep_out = (usb_rx_buf[27]&0x0F);
    }
   if (iCONFIG)
    {   
      usb_setup[0]=0x80;
      usb_setup[1]=0x06; 
      usb_setup[2]=0x00;
      usb_setup[3]=0x03;
      usb_setup[4]=0x00;
      usb_setup[5]=0x00;
      usb_setup[6]=0x04;
      usb_setup[7]=0x00;
      usb_setup[2] = iCONFIG; 
      usb_send_packet(0,0,usb_setup,8);
      usb_status = usb_read_packet(usb_rx_buf);  
    }
   //delay_ms(100); 
   //0xA1|0xFE|0x00|0x00|0x00|0x00|0x01|0x00| - GET_MAX_LUN
   usb_setup[0]=0xA1;
   usb_setup[1]=0xFE; 
   usb_setup[2]=0x00;
   usb_setup[3]=0x00;
   usb_setup[4]=0x00;
   usb_setup[5]=0x00;
   usb_setup[6]=0x01;
   usb_setup[7]=0x00; 
   usb_send_packet(0,0,usb_setup,8);
   usb_status = usb_read_packet(usb_rx_buf);  
   //delay_ms(100); 
   if (usb_status)
     {
        usb_setup[0]=0x02;
        usb_setup[1]=0x01; 
        usb_setup[2]=0x00;
        usb_setup[3]=0x00;
        usb_setup[4]=0x00;
        usb_setup[5]=0x00;
        usb_setup[6]=0x00;
        usb_setup[7]=0x00; 
        usb_send_packet(0,0,usb_setup,8);
        usb_status = usb_read_packet(usb_rx_buf); 
        //delay_ms(100);  
     }
}

void usb_reset_pipe(unsigned char num)
{
  UPRST=1<<num; 
  UPRST=0x00;
}